(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('maddob-lib', ['exports', '@angular/core', '@angular/forms'], factory) :
    (factory((global['maddob-lib'] = {}),global.ng.core,global.ng.forms));
}(this, (function (exports,core,forms) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkdownEditorComponent = /** @class */ (function () {
        function MarkdownEditorComponent(required, maxlength) {
            if (required === void 0) {
                required = false;
            }
            if (maxlength === void 0) {
                maxlength = -1;
            }
            this.required = required;
            this.maxlength = maxlength;
            /**
             * flag for fullscreen mode
             */
            this.fullscreenEnabled = false;
            /**
             * flag for show/hide preview area
             */
            this.previewEnabled = true;
            /**
             * flag for disabling the editor (and all its controls)
             */
            this.disabled = false;
            this.onChange = ( /**
             * @param {?} newValue
             * @return {?}
             */function (newValue) { });
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        Object.defineProperty(MarkdownEditorComponent.prototype, "value", {
            get: /**
             * @return {?}
             */ function () {
                return this._value || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._value = value;
                this.parsedHtml = marked(this._value);
                this.onChange(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.codeMirror = CodeMirror.fromTextArea(this.editor.nativeElement, {
                    mode: 'markdown',
                    lineNumbers: true,
                    autoCloseTags: true,
                    lineWrapping: true,
                    extraKeys: { 'Ctrl-Space': 'autocomplete' }
                });
                this.codeMirror.doc.on('change', ( /**
                 * @param {?} instance
                 * @param {?} change
                 * @return {?}
                 */function (instance, change) {
                    _this.value = instance.getValue();
                }));
                this.resizeCodeMirror();
            };
        /* ControlValueAccessor methods  */
        /* ControlValueAccessor methods  */
        /**
         * @param {?} obj
         * @return {?}
         */
        MarkdownEditorComponent.prototype.writeValue = /* ControlValueAccessor methods  */
            /**
             * @param {?} obj
             * @return {?}
             */
            function (obj) {
                this._value = '';
                if (typeof obj === 'string' && this.codeMirror) {
                    this.codeMirror.setValue(obj);
                    this.onChange(obj);
                }
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        MarkdownEditorComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                console.log('REGISTERING ON CHANGE to', fn);
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        MarkdownEditorComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        MarkdownEditorComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.disabled = isDisabled;
                if (this.codeMirror) {
                    this.codeMirror.setOption('readOnly', isDisabled);
                }
            };
        /* END ControlValueAccessor methods  */
        /**
         * Validate implementation
         *
         * only required and maxlength for now
         */
        /* END ControlValueAccessor methods  */
        /**
         * Validate implementation
         *
         * only required and maxlength for now
         * @param {?} control
         * @return {?}
         */
        MarkdownEditorComponent.prototype.validate = /* END ControlValueAccessor methods  */
            /**
             * Validate implementation
             *
             * only required and maxlength for now
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var result = null;
                if (this.required && this._value.length === 0) {
                    result = { required: true };
                }
                if (this.maxlength > 0 && this.value.length > this.maxlength) {
                    result = { maxlength: true };
                }
                return result;
            };
        /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         */
        /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         * @return {?}
         */
        MarkdownEditorComponent.prototype.resizeCodeMirror = /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var editorContainer = _this.editor.nativeElement.parentNode;
                    _this.codeMirror.setSize(editorContainer.offsetWidth, editorContainer.offsetHeight);
                }), 200);
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.toggleFullscreen = /**
         * @return {?}
         */
            function () {
                this.fullscreenEnabled = !this.fullscreenEnabled;
                this.resizeCodeMirror();
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.togglePreview = /**
         * @return {?}
         */
            function () {
                this.previewEnabled = !this.previewEnabled;
                this.resizeCodeMirror();
            };
        /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param type type of the content that is to be inserted
         * @param value optional value (for special custom content)
         */
        /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param {?} type type of the content that is to be inserted
         * @param {?=} value optional value (for special custom content)
         * @return {?}
         */
        MarkdownEditorComponent.prototype.insertContent = /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param {?} type type of the content that is to be inserted
         * @param {?=} value optional value (for special custom content)
         * @return {?}
         */
            function (type, value) {
                /** @type {?} */
                var from = this.codeMirror.getCursor('from');
                // if value is set, use it, if not get the selection instead
                /** @type {?} */
                var selection = value ? value : this.codeMirror.getSelection();
                /** @type {?} */
                var to = this.codeMirror.getCursor('to');
                /** @type {?} */
                var newCursorPosition = { line: to.line, ch: to.ch };
                /** @type {?} */
                var additionalOffset = 0;
                /** @type {?} */
                var replacement = '';
                switch (type) {
                    case 'bold':
                        replacement = "**" + selection + "**";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 2;
                        break;
                    case 'italic':
                        replacement = "*" + selection + "*";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 1;
                        break;
                    case 'quote':
                        replacement = "> " + this.codeMirror.getLine(from.line);
                        this.codeMirror.replaceRange(replacement, { line: from.line, ch: 0 }, { line: from.line, ch: replacement.length });
                        break;
                    case 'list':
                        replacement = "- " + this.codeMirror.getLine(from.line);
                        this.codeMirror.replaceRange(replacement, { line: from.line, ch: 0 }, { line: from.line, ch: replacement.length });
                        break;
                    case 'link':
                        replacement = "[](" + selection + ")";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 1;
                        break;
                    case 'image':
                        replacement = "![](" + selection + ")";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 2;
                        break;
                    case 'code':
                        replacement = "```\r\n" + selection + "\r\n```";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 4;
                        break;
                    default:
                }
                newCursorPosition.ch += replacement.length - selection.length - additionalOffset;
                this.codeMirror.setCursor(newCursorPosition);
                this.codeMirror.focus();
                this.onChange(this._value);
            };
        MarkdownEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'maddob-markdown-editor',
                        template: "<div class=\"editor-container\">\n\n  <div class=\"header\">\n\n  </div>\n\n  <div class=\"component\">\n\n  </div>\n</div>",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return MarkdownEditorComponent; })),
                            },
                            {
                                provide: forms.NG_VALIDATORS,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return MarkdownEditorComponent; }))
                            }
                        ],
                        styles: [".maddob-markdown-editor-container{display:flex;flex-direction:column;border:1px solid #000}.maddob-markdown-editor-header{display:flex;flex-direction:row;justify-content:space-between;padding:5px}.maddob-markdown-editor-header-left{display:flex;justify-content:flex-start}.maddob-markdown-editor-header-center{flex-grow:0;display:flex;justify-content:center}.maddob-markdown-editor-header-right{display:flex;justify-content:flex-end}.maddob-markdown-editor-content{display:flex;flex-grow:1;flex-direction:row;border-top:1px solid #000}.maddob-markdown-editor{flex-basis:50%;flex-grow:1;text-align:left;overflow:scroll}.maddob-markdown-editor textarea{width:100%;height:100%}.maddob-markdown-preview{text-align:left;flex-basis:50%;border-left:1px solid #ccc;overflow:scroll;padding:5px}.default-height{height:300px}.full-height{height:100%}.fullscreen{background-color:#fff;height:100%;width:100%;left:0;top:0;overflow:hidden;position:fixed;z-index:1000}"]
                    }] }
        ];
        /** @nocollapse */
        MarkdownEditorComponent.ctorParameters = function () {
            return [
                { type: Boolean, decorators: [{ type: core.Attribute, args: ['required',] }] },
                { type: Number, decorators: [{ type: core.Attribute, args: ['maxlength',] }] }
            ];
        };
        MarkdownEditorComponent.propDecorators = {
            editor: [{ type: core.ViewChild, args: ["editor",] }]
        };
        return MarkdownEditorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaddobLibModule = /** @class */ (function () {
        function MaddobLibModule() {
        }
        MaddobLibModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MarkdownEditorComponent],
                        imports: [
                            forms.FormsModule
                        ],
                        exports: [MarkdownEditorComponent]
                    },] }
        ];
        return MaddobLibModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.MarkdownEditorComponent = MarkdownEditorComponent;
    exports.MaddobLibModule = MaddobLibModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=maddob-lib.umd.js.map